import bcrypt


class UsernamePasswordService:
    def __init__(self, users):
        self.__users = {}
        for user in users:
            self.__users[user["name"].lower()] = user["password"]

    def get_users(self):
        return self.__users

    def is_password_valid(self, name: str, password: str) -> bool:
        saved_password = self.__users.get(name.lower(), None)
        if saved_password is None:
            raise ValueError(f'User {name} not found')
        return bcrypt.checkpw(password.encode(), saved_password.encode())
